#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<x_gem.h>
#include	<ctype.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"



int strncmp_PDF(char *str1, char *str2, int len)
	{
	int i=0;

	while(str1[i]==str2[i] && len>i)
		i++;

	if(i==len)
		return(0);
	else
		return(-1);
	}


/*
	********************************************************
	Command2ID v. 1.0
	*********************************************************
	1.0 - first version (RK)
*/

int Command2ID(struct files_pdf *file, char **table)
	{
	int i=0,len=0;

	if(file->buffer!=NULL && file->handle<=0)
		{
		while(strncmp(&file->buffer[file->actual_pos], "endobj", 6)!=0 && file->actual_pos<file->buff_size)						/* Find the beginning of the command	*/
			{
			if(file->buffer[file->actual_pos]=='/' || file->buffer[file->actual_pos]=='\r' || file->buffer[file->actual_pos]=='s')			/* Let's find the beginning of an command or beginning of 'stream'	*/
				{
				while(table[i]!=NULL)
					{
					len=(int)max(strlen(table[i]), strcspn(&file->buffer[file->actual_pos], " \r\n[]></"));
					if(strncmp_PDF(&file->buffer[file->actual_pos], table[i], len)==0)	/*	strcspn(&file->buffer[file->actual_pos], " \r\n[]><"))==0)	*/
						{
						int len2=(strcspn(&file->buffer[file->actual_pos+1], " \r\n[]></")+1);
						if(strlen(table[i])==len2)
							{
							file->actual_pos += strlen(table[i]);
							return(i+1);
							}
						}
					i++;
					}
				}
			i=0;
			file->actual_pos++;
			}
		}
	else
		{
		char command[256]={0}, character=0;
		int pos=0;

		Fseek(file->actual_pos, file->handle, 0);

		while(character!='/')
			{
			read(file->handle, &character, 1);
			if(character=='e')
				{
				read(file->handle, &character, 1);
				if(character=='n')
					return(0);
				else if(character=='/')
					{
					file->actual_pos++;
					break;
					}
				file->actual_pos++;
				}
			file->actual_pos++;
			}

		Fseek(-1, file->handle, 1);
		read(file->handle, &command[0], 255);

		while(command[pos]!='/' && pos<255)						/* Find the beginning of the command	*/
			{
			if(strncmp(&command[pos], ">>", 2)==0)
				return(0);
			pos++;
			}

		if(pos>=255)
			return(0);

		while(table[i]!=NULL)
			{
			if(strncmp(&command[pos], table[i], strcspn(&command[pos], " \r\n[]><"))==0)
				{
				file->actual_pos += strcspn(&command[pos], " \r\n[]><");
				return(i+1);
				}
			i++;
			}
		}

	return(0);
	}



/* ********************************************************
	Read_command v. 1.1
	**************************
	1.0 - first version
	1.1 (20.10.2001) - RK - used static variable output			*/

char *Read_command(struct files_pdf *file)
	{
	char *buffer = &file->buffer[file->actual_pos];
	static char output[256]={0};
	long size;

	buffer = strstr(buffer, "/");

	if(buffer)
		{
		if((unsigned long)buffer<(unsigned long)strstr(&file->buffer[file->actual_pos], ">>"))
			{
			size = (unsigned long)strstr(buffer, " ") - (unsigned long)buffer;

			if(size>((unsigned long)strstr(buffer, "\r") - (unsigned long)buffer))
				size = ((unsigned long)strstr(buffer, "\n") - (unsigned long)buffer);

			if(size>((unsigned long)strstr(buffer, ">>") - (unsigned long)buffer))
				size = ((unsigned long)strstr(buffer, ">>") - (unsigned long)buffer);

			if(size>((unsigned long)strstr(buffer, "[") - (unsigned long)buffer))
				size = ((unsigned long)strstr(buffer, "[") - (unsigned long)buffer);

			if(size>((unsigned long)strstr(buffer, "]") - (unsigned long)buffer))
				size = ((unsigned long)strstr(buffer, "]") - (unsigned long)buffer);

			if(output)
				{
				if(size>255)
					size=255;

				strncpy(&output[0], buffer, size);
				file->actual_pos += size + 1 + (unsigned long)buffer - (unsigned long)&file->buffer[file->actual_pos];
				return(&output[0]);
				}
			}
		}

	return(NULL);
	}



unsigned long Read_object_no(struct files_pdf *file)
	{
	char *buffer = NULL;
	char character=0;
	unsigned long size=0, size1=0, nr=0;

	if(file==NULL)
		return(0L);

	if(file->buffer!=NULL && file->handle<0)
		{
		if(file->buffer[file->actual_pos]==' ')
			{
			while(file->buffer[++file->actual_pos]==' ')	;
			buffer = &file->buffer[file->actual_pos];
			}
		else
			{
			buffer = &file->buffer[file->actual_pos];
			}

		if(buffer[0]=='<' || buffer[1]=='<' || buffer[2]=='<')				/* Is this is a direct object?									*/
			{
			return(-((signed long)file->actual_pos));										/* Then we have to return the position with '-'	*/
			}

		size = (unsigned long)strstr(buffer, " ") - (unsigned long)buffer;
		size1 = min((unsigned long)strstr(buffer, "\r") - (unsigned long)buffer, (unsigned long)strstr(buffer, "\n") - (unsigned long)buffer);

		if(size1<size)
			size = size1;
		nr = atol(buffer);
		}
	else
		{
		Fseek(file->actual_pos, file->handle, 0);
		read(file->handle, &character, 1);
		if(character==' ' || isdigit(character)==0)
			{
			while(isdigit(character)==0)
				read(file->handle, &character, 1);
			}
		Fseek(-1, file->handle, 1);
		buffer=calloc(1, 256);
		read(file->handle, buffer, 256);

		if(buffer[0]=='<' || buffer[1]=='<' || buffer[2]=='<')				/* Is this is a direct object?									*/
			{
			return(-((signed long)file->actual_pos));										/* Then we have to return the position with '-'	*/
			}

		size = (unsigned long)strstr(buffer, " ") - (unsigned long)buffer;
		size1 = (unsigned long)strstr(buffer, "\r") - (unsigned long)buffer;

		if(size1<size)
			size = size1;

		nr = atol(buffer);
		}

	file->actual_pos += size;
	if(file->handle>0)
		Fseek(file->actual_pos, file->handle, 0);
	return(nr);
	}



struct Rectangle *Read_rectangle(struct files_pdf *file)
	{
	struct Rectangle *rect=(struct Rectangle *)calloc(1, sizeof(struct Rectangle)+4);

	if(file==NULL)
		{
		free(rect);
		return(NULL);
		}

	if(file->buffer[file->actual_pos]==' ')			/* Is this correct????											*/
		file->actual_pos++;												/* We don't have such file to check this :(	*/
	if(file->buffer[file->actual_pos]=='[')
		file->actual_pos++;
	if(file->buffer[file->actual_pos]==' ')			/* Is this correct????											*/
		file->actual_pos++;												/* We don't have such file to check this :(	*/

	rect->x1 = Read_object_no(file);
	file->actual_pos++;
	rect->y1 = Read_object_no(file);
	file->actual_pos++;
	rect->x2 = Read_object_no(file);
	file->actual_pos++;
	rect->y2 = Read_object_no(file);
	file->actual_pos++;

	return(rect);
	}