#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"memdebug.h"
#include	"mp_const.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"

struct PDF_Trailer *read_trailer(int );
char *find_trailer(int , long );
BOOLEAN Load_pdf_info(char *, struct PDF_Info *);
void Show_pdf_info(struct PDF_Info *);



/*
 First line should looks like this:
	"%PDF-1.3"
 The only chaning string is the version number. So the line length is constant = 8 chars !!
*/


BOOLEAN Check_1st_line (struct PDF_Info *PDF_info)
{
	char output[10]={0};

	if(PDF_info->file_info->handle || PDF_info->file_info->buffer)
	{
	if(PDF_info->file_info->buffer!=NULL)			/* Is the file opened ? */
		strncpy(&output[0], PDF_info->file_info->buffer, 8);
	else
		{
		Fseek(0, PDF_info->file_info->handle, 0);
		read(PDF_info->file_info->handle, &output[0], 8);
		PDF_info->file_info->actual_pos = Fseek(0, PDF_info->file_info->handle, 0);
		}
	}

	if(strncmp(output, "%PDF-", strlen("%PDF-"))==0)		/* Is it the PDF in the first line?	*/
		{
		PDF_info->Version = 10*atoi(&output[5]) + atoi(&output[7]);
		return (TRUE);
		}
	else
		return(FALSE);
}
