#ifndef _TRAILER									/* ER: does not work else */
#define _TRAILER

#define TRAILER_SIZE		1
#define INFO_OBJECT			2
#define ENCRYPT_OBJECT	3
#define ROOT_OBJECT			4
#define PREV_OBJECT			5
#define TRAILER_ID			6

extern char *trailer_commands[];

typedef struct	PDF_Trailer
	{
	unsigned long	trailer_position;						/* Position of the file trailer			*/
	long	Size;																/* Size of the PDF Document in Bytes	*/
	long	Info_object;												/* Position of */
	unsigned long	Info_object_position;				/* Position of the info object			*/
	long	Encrypt_object;											/*	*/
	unsigned long	Encrypt_object_position;		/* Position of encryption info			*/
	long	Root_object;
	unsigned long objects_list_position;			/* Original object list							*/
	unsigned long objects_list_position2;			/* List of added\changed objects		*/
	unsigned long objects_list_position3;			/* List of added\changed objects		*/
	unsigned long objects_list_position4;			/* List of added\changed objects		*/
	unsigned long objects_list_position5;			/* List of added\changed objects		*/
	unsigned long objects_list_position6;			/* List of added\changed objects		*/
	unsigned long	Root_object_position;
	unsigned long	Prev_object;
	unsigned long	Prev_object_position;
	long	Trailer_ID;
	};

/*
trailer
<<
/Size 100
/Info 44 0 R 
/Encrypt 47 0 R 
/Root 46 0 R 
/Prev 60585 
/ID[<81e70c154ce7af64f0972a92018ea359><81e70c154ce7af64f0972a92018ea359>]
>>
*/

#endif