#include	<ext.h>
#include	<stdarg.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<math.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"filters.h"
#include	"cont_pat.h"
#include	"text_st.h"
#include	"page_con.h"
#include	"windinfo.h"


extern struct _stream_command
	{
	char *name;
	int calls;
	int pos;
	char type;
	}stream_command[];

static int handle_static;

void Init_statistics(void)
	{
	int i;

	handle_static = creat("static.log");

	for(i=0; stream_command[i].name!=NULL; i++)
		{
		stream_command[i].calls = 0;
		stream_command[i].type = 0;
		}
	}


static struct
	{
	char name[52];			/* Name of the function	*/
	unsigned long time_in, time_out;
	unsigned long time_min, time_max;
	unsigned long time_average;
	unsigned long calls;
	}statistics[16];


void Update_statisticks(char *name, BOOLEAN in)
	{
	int i;

	for(i=0; i<16; i++)
		{
		if(strcmp(statistics[i].name, name)==0)
			break;
		if(strlen(statistics[i].name)==0)
			{
			memcpy(&statistics[i].name[0], name, strlen(name));
			statistics[i].time_min = 1;
			break;
			}
		}

	statistics[i].calls++;
	if(in==TRUE)
		statistics[i].time_in = clock();
	else
		{
		statistics[i].time_out = clock();

		if((statistics[i].time_out-statistics[i].time_in)<statistics[i].time_min)
			statistics[i].time_min = statistics[i].time_out-statistics[i].time_in;
		if((statistics[i].time_out-statistics[i].time_in)>statistics[i].time_max)
			statistics[i].time_max = statistics[i].time_out-statistics[i].time_in;

		statistics[i].time_average += (statistics[i].time_out-statistics[i].time_in);
		statistics[i].time_average /= statistics[i].calls;
		}
	}


void Exit_statistics(void)
	{
	int i;
	char text[256]={0};

	write(handle_static, "---------------------------------------------------------------\n", strlen("---------------------------------------------------------------\n"));
	write(handle_static, "Function name               Calls     Min     Max       Average\n", strlen("Function name               Calls     Min     Max       Average\n"));
	write(handle_static, "---------------------------------------------------------------\n", strlen("---------------------------------------------------------------\n"));
	for(i=0; i<16; i++)
		{
		if(strlen(statistics[i].name)>1)
			{
			sprintf(text, "%-25s  %6Ld  %6Ld  %6Ld  %6Ld\n", statistics[i].name, statistics[i].calls, statistics[i].time_min, statistics[i].time_max, statistics[i].time_average);
			write(handle_static, text, strlen(text));
			memset(text, 0, 256);
			}
		}

	write(handle_static, "\n\n-----------------\n", strlen("\n\n-----------------\n"));
	write(handle_static, "Name        Calls\n", strlen("Name        Calls\n"));
	write(handle_static, "-----------------\n", strlen("-----------------\n"));
	for(i=0; stream_command[i].name!=NULL; i++)
		{
		sprintf(text, "%-10s: %4d\n", stream_command[i].name, stream_command[i].calls);
		write(handle_static, text, strlen(text));
		memset(text, 0, 52);
		}
	close(handle_static);
	}